/* added by brian, 9/21/2006: apparently our libc doesn't have this */

#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int
daemon(int nochdir, int noclose)
{
    switch(fork()) {
        case -1:
            perror("fork");
            return -1;

        case 0:  /* child */
            break;

        default:  /* parent */
            _exit(0);
    }

    setsid();

    if(!nochdir)
        chdir("/");

    if(!noclose) {
        int fd;

        /* naive */
        close(0);
        close(1);
        close(2);

        fd = open("/dev/null", O_RDONLY);
        dup(fd);
        dup(fd);
    }
    
    return 0;
}
