# Generated automatically from Makefile.in by configure.
##############################################################
# Makefile
#
# SWILL
##############################################################


prefix     = /usr/local/arm-elf
exec_prefix= ${prefix}

SHELL = /bin/sh
INCLUDE_DIR = $(prefix)/include
LIB_DIR = $(exec_prefix)/lib
RANLIB  = ranlib

# Installer

INSTALL        = ./install-sh -c
INSTALL_DATA   = ${INSTALL} -m 644
INSTALL_PROGRAM= ${INSTALL} -m 755

all: static

static:
	cd Source/Objects; $(MAKE) -f arm-elf.mk
	cd Source/SWILL; $(MAKE) -f arm-elf.mk static

shared:
	cd Source/SWILL; $(MAKE) -f arm-elf.mk shared

install:
	@for i in *.so; \
	   do \
	     if test -f $$i; then \
	        echo "Installing $(LIB_DIR)/$$i"; \
	        $(INSTALL_PROGRAM) $$i $(LIB_DIR)/$$i; \
             fi; \
           done;
	@for i in *.a; \
	   do \
	     if test -f $$i; then \
	     echo "Installing $(LIB_DIR)/$$i"; \
	     $(INSTALL_DATA) $$i $(LIB_DIR)/$$i; \
	     $(RANLIB) $(LIB_DIR)/$$i; \
	     fi; \
           done;

	@echo "Installing $(INCLUDE_DIR)/swill.h..."
	@$(INSTALL_DATA) Include/swill.h $(INCLUDE_DIR)/swill.h

clean:
	cd Source/Objects; $(MAKE) -f arm-elf.mk clean
	cd Source/SWILL; $(MAKE) -f arm-elf.mk clean
	rm -rf *.so libswill*






